<#import "datasource-utils.ftl" as u>

<#--
components:
-->
<#--
  responses:
-->

<#macro http204>
    204:
      description: If a request returns no results, it will return an empty HTTP response with status 204 - "no content".
</#macro>

<#macro http404>
    404:
      description: "Not Found."
</#macro>

<#macro errorResponse>
    ErrorResponse:
      description: |
        Error.  Errors fall into two main categories, and include:

        * Validation errors, which arise as a result of rules in the application's business logic being broken. These are part of the normal operation of the system. A response with validation errors has a code value of -4.
        * Unrecoverable errors, which are errors with the system itself. These are not part of the normal operation of the system

      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorModel'
        application/xml:
          schema:
            $ref: '#/components/schemas/ErrorModel'
</#macro>

<#macro default>
    default:
      $ref:  "#/components/responses/ErrorResponse"
</#macro>